
# This is free software.  See LICENSE for terms.
# Copyright 2004 - 2015, Patricia Kirk.

import os, sys, subprocess
from time import strftime

labels = []

try:
    lines = open('commands').readlines()
    for line in lines:
	if line[0] == ':':
	    labels.append(line[1:].strip())
    for label in ['location', 'common', '98', '99']:
	labels.remove(label)
except:
    sys.exit()

DATADIR = ''

try:
    lines = open('../config.h').readlines()
    for line in lines:
	if line.find('DATA_ROOT_DIR') >= 0:
	    DATADIR = '%s/salmon' % line.strip().split(' ')[-1].replace('"', '')
	    if not os.path.exists(DATADIR):
		DATADIR = '../data/'
		if not os.path.exists('%s' % DATADIR):
		    DATADIR = ''
	if DATADIR and not os.path.exists('%s/000.gz' % DATADIR):
	    DATADIR = ''
except:
    pass

if DATADIR == '../data/':
    DATADIR = 'data/'

if DATADIR:
    DATADIR = 'datadir=%s' % DATADIR

OGG123 = ''

try:
    OGG123 = os.popen('locate bin/ogg123').readline().strip()
except:
    pass

FLITE = ''

try:
    FLITE = os.popen('locate bin/flite').readline().strip()
except:
    pass

DISPLAY = ''

if os.environ.has_key('SSH_CLIENT') and os.environ['SSH_CLIENT'].find(':') < 0:
    DISPLAY = 'display=' + os.environ['SSH_CLIENT'].split(' ')[0] + ':0\n'
elif os.environ.has_key('SSH_CONNECTION') and os.environ['SSH_CONNECTION'].find(':') < 0:
    DISPLAY = 'display=' + os.environ['SSH_CONNECTION'].split(' ')[0] + ':0\n'

OS = os.popen('uname').readline().strip()
LINUX = 0
setting = ''

if OS =='Linux':
    LINUX = 1
    acad = 'AC'
    batf = 'BAT'
    batn = 'BAT'
    base = '/sys/class/power_supply'
    lines = os.listdir(base)
    for line in lines:
	if line.find('AC') >= 0:
	    files = os.listdir(os.path.join(base, line))
	    for file in files:
		if file == 'online':
		    acad = os.path.join(line, file)
		    break
	if line.find('BAT') >= 0:
	    files = os.listdir(os.path.join(base, line))
	    files.sort()
	    for file in files:
		if file.find('full') >= 0:
		    batf = os.path.join(line, file)
		    break
	    for file in files:
		if file.find('now') >= 0:
		    batn = os.path.join(line, file)
		    break
    setting = '%s,%s,%s' % (acad.replace('_', '^'), batf.replace('_', '^'), batn.replace('_', '^'))

lines = open('commands').readlines()

now = map(lambda l: int(l), strftime('%H:%M:%S').split(':'))
now[2] += 90

for i in range(len(lines)):
    if lines[i].startswith('#'):
	continue
    if LINUX and setting and lines[i].find('powerstate') >= 0:
	lines[i] = '%s\\\n\t_setting=%s\n' % (lines[i].strip(), setting)
    if not DATADIR:
	if lines[i].find('pixmap') >= 0 and lines[i].strip() != 'pixmap=1':
	    lines[i] = '#' + lines[i]
    if not OGG123:
	if lines[i].find('sound') >= 0:
	    line = lines[i]
	    x = line.find('sound')
	    y = line[x:].find('=') + x + 1
	    if line[y] != '-':
		x = y
		while line[y].isdigit():
		    y += 1
		if int(line[x:y]) > 6:
		    j = int(line[x:y])
		    k = 0
		    while j:
			k = (k + 1) % 6
			j -= 1
		    k += 1
		    line = '%s%d%s' % (line[:x], k, line[y:])
		    lines[i] = line
    if not FLITE:
	if lines[i].find('sound') >= 0:
	    line = lines[i]
	    x = line.find('sound')
	    y = line[x:].find('=') + x + 1
	    x = y
	    while line[y] == '-' or line[y].isdigit():
		y += 1
	    if int(line[x:y]) < 0:
		j = abs(int(line[x:y]))
		k = 0
		if OGG123:
		    l = 12
		else:
		    l = 6
		while j:
		    k = (k + 1) % l
		    j -= 1
		if OGG123:
		    k += 11
		else:
		    k += 1
		line = '%s%d%s' % (line[:x], k, line[y:])
		lines[i] = line
    if OGG123 and lines[i].startswith(':common'):
	lines[i + 1] = '%saudiodev\naudiocmd=%s -q\n' % (lines[i + 1], OGG123)
    if DATADIR and lines[i].startswith(':common'):
	lines[i + 1] = '%s%s\n' % (lines[i + 1], DATADIR)
    if FLITE and lines[i].startswith(':common'):
	lines[i + 1] = '%stalker=%s\n' % (lines[i + 1], FLITE)
    if lines[i].find('reset=12:00') >= 0:
	now[1] += 2
	lines[i] = lines[i].replace('12:00', ('%d:%d' % (now[0], now[1])))
    if lines[i].find('timer=0:0:0') >= 0:
	lines[i] = lines[i].replace('0:0:0', '0:0:%d' % now[2])
    if lines[i].startswith(':location'):
	if DISPLAY:
	    lines[i + 1] = '\n%s%s\n' % (lines[i + 1], DISPLAY)
	else:
	    lines[i + 1] = ''

tabs = open('/etc/fstab').readlines()
mounts = []
for line in tabs:
    if line.find(':') > 0:
	line = line.strip()
	words = []
	while line:
	    x = 0
	    while not line[x].isspace():
		x += 1
	    words.append(line[:x])
	    while x <= len(line) and line[x].isspace():
		x += 1
	    line = line[x:]
	    if x >= len(line):
		words.append(line)
		break
	mounts.append([words[0], words[1]])

if mounts:
    lines.extend(['\n:mounts\n\n',
		    '# Test current u/mount status of network\n',
		    '# file systems listed in /etc/fstab.\n\n'])
    i = 0
    for line in mounts:
	lines.append('line=mount=%s_setting=|%s|_color1=green_color2=yellow_color3=red\n' %
		    (line[1], line[0][:line[0].find('/') + 1]))
	i += 1
	if i > 23:
	    break
	if not i % 6:
	    lines.append('\n')
    lines.append('appname=Mounts\ngoto :location\n')
    labels.append('mounts')

tabs = open('/etc/hosts').readlines()
mounts = []
for line in tabs:
    if line.find('local') >= 0 or line.find('#') >= 0:
	continue
    line = line.strip()
    words = []
    while line:
	x = 0
	while not line[x].isspace():
	    x += 1
	while x <= len(line) and line[x].isspace():
	    x += 1
	line = line[x:]
	if x >= len(line):
	    mounts.append(line)
	    break

if mounts:
    lines.extend(['\n:hosts\n\n',
		    '# Test current access status of remote hosts listed in /etc/hosts.\n',
		    '# This will only work if salmon is run SUID as it requires\n',
		    '# a raw socket to send and receive ping packets.\n\n'])
    i = 0
    for line in mounts:
	lines.append('line=remotehost=%s_setting=|%s|_color1=green_color2=yellow_color3=red\n' % (line, line.title()))
	i += 1
	if i > 23:
	    break
	if not i % 6:
	    lines.append('\n')
    lines.append('appname=Hosts\ngoto :location\n')
    labels.append('hosts')

os.chdir('..')
open('commands', 'w').writelines(lines)

test = 0

for label in labels:
    try:
	os.system('clear')
	if not DATADIR:
	    print '\n\tNote: Background and moon graphics files not found.'
	    print '\t\tSome tests will fail.'
	    DATADIR = 1
	test += 1
	print '\ntest #%d ./salmon read commands,%s' % (test, label)
	lines = os.popen('./salmon print commands,%s' % label).readlines()
	for line in lines:
	    print line[:-1]
	subprocess.check_call(['./salmon', 'read', 'commands,%s' % label])
    except subprocess.CalledProcessError:
	try:
	    raw_input('\tWell, that didn\'t work.\n\n\tPress Enter: ')
	except KeyboardInterrupt:
	    break
    except KeyboardInterrupt:
	break

if os.path.exists('commands'):
    os.remove('commands')

sys.exit()
