/* This is free software.  See LICENSE for terms.
 * Copyright 2004 - 2015, Patricia Kirk.
 */

#ifndef PROTO_H
#define PROTO_H

#include "structs.h"

/* checkevents.c */
void checkEvents();
int disMount(struct lineopts *);
int itsDownload(struct lineopts *, int);
int itsVolume(struct lineopts *, int, int, int, int);
int itsaTalker(struct lineopts *);
int itsCalendar(struct lineopts *);
int itsaTimer(struct lineopts *, int, int, int);
int itsElapsed(struct lineopts *, int, int, int);
int calcPhase(int, int, int, int);
time_t getExpiration(struct lineopts *);
time_t getDuration(struct lineopts *);
void adjTimer(struct lineopts *, int, int, int);
void adjAlarm(struct lineopts *, int, int, int);

/* checklines.c */
void checkLines();
int getIndex(const char *);
struct lineopts *parseLine(char *);
void printTop();
void printLines();

/* main.c */
void initLines();
void spaceLines();
void bindPort(int *, int *, const char *);
int main(int, char**);

/* parseargs.c */
void parseArgs(int, char **);
char *findName(int);
int findIndex(const char *);
int hasArg(int);
char *switchOpt(int, char *, int, int);
char **readArgs(char *, char *, int);
void printOpts();

/* refresh.c */
void getOSVals();
void getMem();
void getSwap();
void getSplit();
void getProcs();
void getABC();
void getPower();
void getTherm();
void getVolume();
void getUptime();
void getLoads();
void getHostNet();
void readFile(char *, char *);
void devDevice(struct lineopts *);
void mntPoint(struct lineopts *);
void setColor(struct lineopts *, int);
int interFace(struct lineopts *);
int remoteHost(struct lineopts *);
int devInfo(struct lineopts *);

/* utils.c */
void setMinums();
void setRequired();
int parseStrtol(char *, int, char *);
void readAloud(int);
void makeNoise(int);
void execComm(char *);
void execFunc(char *);
int stringcpy(char *, char *, int);
int stringcat(char *, char *, int);
void splitSeconds(int *, int *, int *, int *, int);
int findExecutable(char *, int, char *);
int execShutdown(int);
void getNext(time_t, int);
void getPhase(time_t, char *);
int ping(struct lineopts *);
int checkEcho();
int openSocket(char *, int);
void setClock();
void checkSync();
void checkCtl();

/* window.c */
void checkSocket();
void checkFunc();
void initWindow(int, char **);

/* xutils.c */
int pixAlloc(char *);
void drawSlider(struct lineopts *);
void lineToDraw(char *, struct lineopts *);
void formatLine(int, struct lineopts *, double, char *);
void logMessage(char *);
void allocFailed(char *);
void gdayMate(char *, char *);		/* Needs maindisplay */
int readPixmap(struct pixstack *, char *);
char *getColor(char *, float);
void initPixlist();
void scaleGraphic(int, int);
void checkMoon();
void Redraw();
void Update();

#endif	/* PROTO_H */
